package ass.excercises.cvi7.demo4;

import io.reactivex.netty.protocol.http.server.HttpServer;
import io.reactivex.netty.protocol.http.server.HttpServerBuilder;


import io.reactivex.netty.protocol.http.server.HttpServerRequest;
import io.reactivex.netty.protocol.http.server.HttpServerResponse;

import java.io.IOException;
import java.io.UncheckedIOException;
import java.nio.file.Files;
import java.nio.file.Paths;





import org.apache.commons.lang3.RandomStringUtils;
import org.apache.commons.lang3.RandomUtils;

import rx.Observable;
import javaslang.control.Try;

public class DynamicServerAjaxSnippets {
	
	private static SlowRandomService randService = new SlowRandomService();
	
	public static void main(String[] args) {
		//ExamplesEnvironment env = ExamplesEnvironment.newEnvironment(HelloWorldServer.class);

		HttpServer<String, String> server = new HttpServerBuilder<String, String>(ServerConfig.SERVER_PORT, 
        		(req, resp) ->
					req.getPath().startsWith("/dynamic/") ? 
							handleDynamicRequest(req, resp) :
							resp.writeBytesAndFlush(readFile(req.getPath()))
        ).build();

		server.startAndWait();
	}
	
	private static Observable<Void> handleDynamicRequest(HttpServerRequest<String> req, HttpServerResponse<String> resp) {
		if(req.getPath().contains("randAlpha")) {
			return resp.writeAndFlush(randService.randomAlhpa());
		}else if(req.getPath().contains("randAlphaNum")) {
			return resp.writeAndFlush(randService.randomAlhpaNum());
		}else if(req.getPath().contains("randNum")) {
			return resp.writeAndFlush(randService.randomNum());
		}else {
			return resp.writeAndFlush("No random service: '"+req.getPath()+"'");
		}
	}

	private static byte[] readFile(String filepath) {
		filepath = "document_root/" + filepath.replace("/", "");
		System.out.println("Requesting: '"+filepath+"'");
		try {
			return Files.readAllBytes(Paths.get(filepath));
		}catch(IOException ioe) {
			throw new UncheckedIOException(ioe);
		}
	}
	
}
